import java.util.ArrayList;
import java.util.List;

public class TrainCarriage {
    private int maxSeats;
    private List<Passenger> passengerList;

    public TrainCarriage(int maxSeats, List<Passenger> passengerList) {
        this.maxSeats = maxSeats;
        this.passengerList = passengerList;
    }

    public TrainCarriage(int maxSeats) {
        this.maxSeats = maxSeats;
        passengerList = new ArrayList<>();
    }

    public int getMaxSeats() {
        return maxSeats;
    }

    public void setMaxSeats(int maxSeats) {
        this.maxSeats = maxSeats;
    }

    public List<Passenger> getPassengerList() {
        return passengerList;
    }

    public void setPassengerList(List<Passenger> passengerList) {
        this.passengerList = passengerList;
    }

    public boolean addPassenger(Passenger passenger){
        if(passengerList.size() < maxSeats){
            this.passengerList.add(passenger);
            System.out.println("New passenger added");
            return true;
        }
        System.out.println("Train carriage already full");
        return false;
    }

    public void displayPassengers(){
        for(Passenger passenger : this.passengerList){
            passenger.display();
        }
    }

    public void displayPassengersNameSurname(){
        for(Passenger passenger : this.passengerList){
            System.out.println(passenger.getName() + " " + passenger.getSurname());
        }
    }

    public void displayCarriageInfo(){
        System.out.println("Total number of seats: " + maxSeats);
        System.out.println("the number of seats that are taken: " + passengerList.size());
        System.out.println("the number of seats that are available: " + (maxSeats - passengerList.size()));
        displayPassengers();
    }

    public int countEntitledToSeniorDiscount() {
        int counter = 0;
        for(Passenger passenger : this.passengerList){
            if(passenger.getAge() >= 65){
                counter++;
            }
        }
        return counter;
    }

}
